Foreman - Bug #24284

Hammer/API - wrong error message
07/18/2018 11:48 AM - Marek Hulan

Status: Closed
Priority: Normal
Assignee: Marek Hulén
Category: Authentication
Target version: 1.20.0
Difficulty: Fixed in Releases: 1.20.0
Triaged: No Found in Releases:
Bugzilla link: 1602367 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/5848
Description

Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=1602367

Description of problem:

When we do brute force password attack via hammer (min. 30 trying), it returns the message "Invalid username or password."
After that we put a correct credential, but hammer/API still return the same message "Invalid username or password.". It is little
confusing.

Version-Release number of selected component (if applicable):
Sat6.4#11

How reproducible:
100%

Steps to Reproduce:

1. We have got Sat6.4 and client machine.

2. We register the client machine to Satellite 6.4 repo and install hammer (standalone)

> yum install -y tfm-rubygem-hammer_cli_katello

> hammer --fetch-ca-cert https:/satellite.example.com/

> install /root/.hammer/certs/satellite.example.com_443.pem /etc/pki/ca-trust/source/anchors/
> update-ca-trust

3. Check hammer

hammer -u admin -p correct_password user list

4. Brute force password attack

for i in {1..30}; do hammer -u admin -p bad_password user list; done
Invalid username or password.
Invalid username or password.

Invalid username or password.
Invalid username or password.

5. Check hammer with the correct password

hammer -u admin -p correct_password user list

Actual results:
we get the message "Invalid username or password."

Expected results:
We should get the message "Too many tries, please try again in a few minutes.". The same as via WebUI.

Additional info:

hammer -d -u admin -p correct_password user list

[DEBUG 2018-07-18T04:58:00 API] Using authenticator: HammerCLIForeman::Api::InteractiveBasicAuth
[ERROR 2018-07-18T04:58:00 API] 401 Unauthorized

[DEBUG 2018-07-18T04:58:00 API] {

"error" => {

"message" => "Unable to authenticate user "

}

}

[DEBUG 2018-07-18T04:58:00 Exception] Using exception handler
HammerCLIForeman::ExceptionHandler#handle_foreman_unauthorized
[ERROR 2018-07-18T04:58:00 Exception] Invalid username or password.
Invalid username or password.

[ERROR 2018-07-18T04:58:00 Exception]

HammerCLIForeman::Api::UnauthorizedError (Invalid username or password.):

Related issues:
Copied to Hammer CLI - Bug #24285: Hammer/API - wrong error message Closed

Associated revisions

Revision ce2219cf - 07/18/2018 04:28 PM - Marek Hulan
Fixes #24284 - distinguish bruteforce in API

History

#1 - 07/18/2018 11:50 AM - Marek Hulan
- Copied to Bug #24285: Hammer/API - wrong error message added

#2 - 07/18/2018 11:56 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/5848 added

#3 - 07/18/2018 05:01 PM - Marek Hulan
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset ce2219cf7aa441f7219efa0bf367ef3138d14c9f.

#4 - 07/19/2018 04:51 AM - Marek Hulan

- Subject changed from Hammer/API - wrong error message
to Hammer/API - wrong error message

- Target version set to 1.20.0

- Fixed in Releases 1.20.0 added
